/*
union bits64{
   int8 b[8];
   int16 d[4];
   int32 w[2];
}bits_64;
*/
typedef union bits64 int64;
int64 scratch64;

//BORROW 
//Macro to add two 64bit values. Result into the first
#define	m_add64x64() 
   #asm
   bsf		STATUS,RP0
   MOVF		b_byt0,W
   addwf	a_byt0
   btfsc	STATUS,C
   incf		a_byt1
   movf		b_byt1,w
   addwf	a_byt1
   btfsc	STATUS,C
   incf		a_byt2
   movf		b_byt1,w
   addwf	a_byt2
   btfsc	STATUS,C
   incf		a_byt3
   movf		b_byt1,w
   addwf	a_byt3
   btfsc	STATUS,C
   incf		a_byt4
   movf		b_byt1,w
   addwf	a_byt4
   btfsc	STATUS,C
   incf		a_byt5
   movf		b_byt1
   addwf	a_byt5
   btfsc	STATUS,C
   incf		a_byt6
   movf		b_byt1,w
   addwf	a_byt6
   btfsc	STATUS,C
   incf		a_byt7
   movf		b_byt1,w
   addwf	a_byt7
   bcf		STATUS,RP0
   #endasm
//Macro as above, to subtract two 64bit values.
#define	m_sub64x64() 
   #asm
   bsf		STATUS,RP0
   movf		b_byt0,w
   subwf	a_byt0
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt1
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt2
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt3
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt4
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_0
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_0:
   nop	
   movf		b_byt1,w
   subwf	a_byt1
   btfsc	STATUS,C
   movlw	1
   subwf	a_byt2
   btfsc	STATUS,C
   goto		m_sub64x64_1
   movlw	1
   subwf	a_byt3
   btfsc	STATUS,C
   goto		m_sub64x64_1
   movlw	1
   subwf	a_byt4
   btfsc	STATUS,C
   goto		m_sub64x64_1
   movlw	1
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_1
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_1
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_1:
   nop	
   movf		b_byt2,w
   subwf	a_byt2
   btfsc	STATUS,C
   goto		m_sub64x64_2
   movlw	1
   subwf	a_byt3
   btfsc	STATUS,C
   goto		m_sub64x64_2
   movlw	1
   subwf	a_byt4
   btfsc	STATUS,C
   goto		m_sub64x64_2
   movlw	1
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_2
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_2
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_2:
   nop	
   movf	b_byt3,w
   subwf	a_byt3
   btfsc	STATUS,C
   goto		m_sub64x64_3
   movlw	1
   subwf	a_byt4
   btfsc	STATUS,C
   goto		m_sub64x64_3
   movlw	1
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_3
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_3
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_3:
   nop	
   movf		b_byt4,w
   subwf	a_byt4
   btfsc	STATUS,C
   goto		m_sub64x64_4
   movlw	1
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_4
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_4
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_4:   
   nop	
   movf		b_byt5,w
   subwf	a_byt5
   btfsc	STATUS,C
   goto		m_sub64x64_5
   movlw	1
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_5
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_5:
   nop	
   movf		b_byt6,w
   subwf	a_byt6
   btfsc	STATUS,C
   goto		m_sub64x64_6
   movlw	1
   subwf	a_byt7
   btfss	STATUS,C
   goto		m_sub64x64_7
m_sub64x64_6:
   movf		b_byt7,w
   subwf	a_byt7
m_sub64x64_7:
   nop
   bcf		STATUS,RP0
   #endasm

/*
  #asm
M_shiftleft64	macro	dst
	bcf	3,0
	rlf	dst+7
	rlf	dst+6
	rlf	dst+5
	rlf	dst+4
	rlf	dst+3
	rlf	dst+2
	rlf	dst+1
	rlf	dst
	endm
M_shift_right64	macro	dst
	bcf	3,0
	rlf	dst
	rlf	dst+1
	rlf	dst+2
	rlf	dst+3
	rlf	dst+4
	rlf	dst+5
	rlf	dst+6
	rlf	dst+7
	endm
  #endasm
*/
#asm
M_check_zero64	macro	dst
	bcf		BORROW
	movf	dst+7
	btfss	status,z
	bsf		BORROW
	movf	dst+6
	btfss	status,z
	bsf		BORROW
	movf	dst+5
	btfss	status,z
	bsf		BORROW
	movf	dst+4
	btfss	status,z
	bsf		BORROW
	movf	dst+3
	btfss	status,z
	bsf		BORROW
	movf	dst+2
	btfss	status,z
	bsf		BORROW
	movf	dst+1
	btfss	status,z
	bsf		BORROW
	movf	dst+0
	btfss	status,z
	bsf		BORROW
	endm
	#endasm

/*
#asm
M_set_zero64	macro	dst
	clrf	dst+7
	clrf	dst+6
	clrf	dst+5
	clrf	dst+4
	clrf	dst+3
	clrf	dst+2
	clrf	dst+1
	clrf	dst+0
	endm
	#endasm
*/
#asm
M_bit_test64	macro	dst,bit,temp
	movf	dst+0,w
	movwf	temp
	movlw	8
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+1,w
	movwf	temp
	movlw	16
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+2,w
	movwf	temp
	movlw	24
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+3,w
	movwf	temp
	movlw	32
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+4,w
	movwf	temp
	movlw	40
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+5,w
	movwf	temp
	movlw	48
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+6,w
	movwf	temp
	movlw	56
	subwf	bit,w
	btfss	status,c
	goto	bit_test_0
	movf	dst+7,w
	movwf	temp
bit_test_0
	movlw	0x7
	andwf	bit
	btfsc	status,z
	goto	bit_test_1
	decf	bit
	rrf	temp
	goto	bit_test_0
bit_test_1
	bcf		BORROW
	btfss	temp,0
	bsf		BORROW
	endm
	#endasm

/*
int64 shif_tleft64(int64){//shift 64 bit left
	int64_h<1;
	if(((signed long)int64_l)<0)
	{int64_h | 0x01;}
	int64_l<1;
}
int64 shift_right64(int64){//shift 64 bit right
	int64_l>1;
	if((int64_l & 0x01)>1)
	{int64_1 | 0x80;}
	int64_h>1;
}
int64 clear_64(int64){//clear 64 bit, return 64 bit=0
int64 set_zero64(int64){
  int64 temp;
   temp.w[0]=0;
   temp.w[1]=0;
   return temp;
}
int64 test_zero_64(int64 temp){//64 bit test temp=0, return BORROW
  BORROW=0;
	if(temp.w[0]>0){BORROW=1;}
	if(temp.w[1]>0){BORROW=1;}
}

int64 add64x64(int64 a,int64 b){//64 bit returns (a=a+b)
unchar addtemp;unlong temp;
	temp=((unsigned long)a.d[0])+((unsigned long) b.d[0]);
	a.d[0]=temp;
	if((temp & 0x10000)>0){addtemp=1;}
	temp=((unsigned long)a.d[1])+((unsigned long) bd.[1])+((unsigned long)addtemp);
	ad.[1]=temp;addtemp=0;
	if((temp & 0x10000)>0){addtemp=1;}
	temp=((unsigned long)a.d[2]+((unsigned long) b.d[2])+((unsigned long)addtemp);
	ad[2]=temp;addtemp=0;
	if((temp & 0x10000)>0){addtemp=1;}
	temp=((unsigned long)a.d[3])+((unsigned long) b.d[3])+((unsigned long)addtemp);
	ad.[3]=temp;
  return a;
}
void bit_set64 (unchar num_bit){
	if(num_bit<8)
	{
		num_bit = num_bit & 0x07;
		int64_0=int64_0 | 1<<num_bit;
		return;
	}
}
	if(num_bit<16)
	{
		num_bit=num_bit&0x07;
		dword_1=(dword_1 | 1<<num_bit);
		return;
	}
	if(num_bit<24)
	{
		num_bit=num_bit&0x07;
		dword_2=(dword_2 | 1<<num_bit);
		return;
	}
	if(num_bit<32)
	{
		num_bit=num_bit&0x07;
		dword_3=(dword_3 | 1<<num_bit);
		return;
	}
	if(num_bit<40)
	{
		num_bit=num_bit&0x07;
		dword_4=(dword_4 | 1<<num_bit);
		return;
	}
	if(num_bit<48)
	{
		num_bit=num_bit&0x07;
		dword_5=(dword_5 | 1<<num_bit);
		return;
	}
	if(num_bit<56)
	{
		num_bit=num_bit&0x07;
		dword_6=(dword_6 | 1<<num_bit);
		return;
	}
	if(num_bit<56)
	{
		num_bit=num_bit&0x07;
		dword_7=(dword_7 | 1<<num_bit);
		return;
	}
}
*/


/*
#define	M_shiftright64(x) shift_right(&x,8,0)//Macro to zero a 64bit value
#define	M_set_zero64(x) x.w[0]=0L;x.w[1]=0L
#define	M_iszero64(x) ((x.w[0]==0L)&&(x.w[1]==0L))
#define bit64_set(x,i) x.b[i>>3]|=(1<<(i&7))
*/
int64 add64x64(int64 a,int64 b) {//simple 64 bit addition call - returns (a+b)
		m_add64x64(a,b);
  	return a;
}
int64 sub64x64(int64 a,int64 b) {//64 bit subtraction call as above - returns (a-b)
  	m_sub64x64(a,b);
   return a;
}
int64 cast32x64(int32 a) {//routine to convert a 32bit int to 64bit
   int64 temp;
   int8 i;
   temp.w[0]=a;
   temp.w[1]=0L;//and clear the top half
   return temp;
}
int64 compare_64(int64 a,int64 b) {//Internal compare_ two 64 bit values
//Performs a-b. BORROW(global variable)=1 A>B
	m_sub64x64(a,b);
  if (CARRY==0) BORROW=TRUE;
  else BORROW=FALSE;
  return a;
}







/*
int64 mult32x32(int32 a,int32 b) {
   //Routine to multiply two 32bit values with a 64bit result
   int64 temp2;
   int8 i;
   //zero output
  	M_set_zero64(temp2);
   //Not trying to break any records for efficiency, so all in C, and not using
   //hardware multiply
   //start by moving the int32, into the low half of the int64
   scratch64=cast32x64(b);
   //Now need to work through all 32 bits in the 'a' variable
   for (i=0;i<32;i++) {
      //if source bit in 'a' is one, perform addition
      if (bit_test(a,i))
     	M_add64x64(temp2,scratch64);
      //rotate the second value here
  	M_shiftleft64(scratch64);
   }
   return temp2;}

int64 div64x64(int64 a,int64 b) {
   //Routine to divide 'a' by 'b' in 64bit arithmetic
   //returns with result, leaving remainder in the scratch64
   int8 bitno=0,ctr;
   int64 temp;
   if (M_check_zero64(b)) {
      if (!M_check_zero64(a)) {
         //need maximum result
         temp.w[0]=temp.w[1]=0xFFFFFFFF;
     	M_set_zero64(scratch64);
         return temp;
      }
      //Else 0/0=1
  	M_set_zero64(temp);
  	M_set_zero64(scratch64);
      temp.b[0]=1;
      return temp;
      //return 1
   }
  	M_set_zero64(temp);
   bitno=0;
   //Now position divisor to suit find top bit in A, and rotate b till it's
   //top bit is in the same position
   if (a.w[1]!=0) {
      for(ctr=31;!bit_test(a.w[1], ctr);ctr--) ;
      //Now rotate b till it's top bit matches.
      while (!bit_test(b.w[1], ctr)) {
     	M_shiftleft64(b);
         ++bitno;
      }
   }
   else {
      for(ctr=31;!bit_test(a.w[0], ctr);ctr--) ;
      bitno=ctr;
      //Now rotate b till it's top bit matches.
      while (!bit_test(b.w[1], ctr)) {
     	M_shiftleft64(b);
         ++bitno;
      }
   }     
   //bitno now stores how far b had to rotate
   while (bitno) {
      //Loop for bitno bits, performing subtract, shift & test
      scratch64=compare_64(a,b);
      if (!BORROW) {
         a=scratch64;
         //Set output bit if no borrow
         bit64_set(temp,bitno);
      }
      if (M_check_zero64(a)) break;
  	M_shiftright64(b);
      bitno--;
   }
   scratch64=a;
   return temp;
} 
*/